package com.cs;

import java.io.File;
import java.util.Calendar;

import com.cs.util.LicenseUtil;
import com.spire.xls.CellRange;
import com.spire.xls.CellStyle;
import com.spire.xls.FileFormat;
import com.spire.xls.PageSetup;
import com.spire.xls.Workbook;
import com.spire.xls.Worksheet;

public class SampleSingle {

    public static void main(String[] args) {
        convertExcelToPdf();
    }

    public static void convertExcelToPdf() {

        File file = new File("D:\\Test\\Compass Health Financials March  2023 Distribution.xlsx");
        String outputFileName ="D:\\Test\\Compass Health Financials March  2023 Distribution.pdf";

        LicenseUtil.applyApiLicense();

        System.out
            .println(Calendar.getInstance().getTime() + ":::::::::::: Start processing file ::: " + file.getName());

        Workbook workbook = new Workbook();
        workbook.loadFromFile(file.getPath());
        // workbook.getConverterSetting().setSheetFitToWidth(true);
        workbook.getConverterSetting().setSheetFitToPage(true);
        workbook.getConverterSetting().isReCalculateOnConvert(false);

        Workbook workbookTest = new Workbook();

        for (int i = 2; i < workbook.getWorksheets().size(); i++) {

            Worksheet worksheet = workbook.getWorksheets().get(i);
            // Worksheet worksheet = workbook.getWorksheets().get("1");

            if (worksheet.getPivotTables().getCount() == 0) {
                worksheet.CalculateAllValue();
            }

            // worksheet.CalculateAllValue();
            /*
             for (int row = worksheet.getFirstRow(); row <= worksheet.getLastRow(); row++) {
            	boolean rowIsHide = worksheet.getRowIsHide(row);
             if (rowIsHide) {
                 worksheet.showRow(row);
             }
            //                CellStyle style = worksheet.getRows()[row-1].getCellStyle();
             	CellStyle style = worksheet.getDefaultRowStyle(row);
             	style.setShrinkToFit(true);
             	style.setWrapText(false);
            }
            
             for (int col = worksheet.getFirstColumn(); col <= worksheet.getLastColumn(); col++) {
             	boolean columnIsHide = worksheet.getColumnIsHide(col);
             if (columnIsHide) {
                 worksheet.showColumn(col);
             }
            //                CellStyle style = worksheet.getColumns()[col-1].getCellStyle();
             	CellStyle style = worksheet.getDefaultColumnStyle(col);
             	style.setShrinkToFit(true);
             	style.setWrapText(false);
             }
             */

            Boolean isRowMerged = false;
            Boolean isColMerged = false;

            CellRange[] rows = worksheet.getRows();
            CellRange[] columns = worksheet.getColumns();

            /*for (int r = 0; r < rows.length; r++) {
            if (rows[r].hasMerged()) {
            	rows[r].autoFitColumns();
            	isRowMerged = true;
                break;
            }
            }
            
            for (int r = 0; r < columns.length; r++) {
            if (columns[r].hasMerged()) {
            	rows[r].autoFitRows();
            	isColMerged = true;
                break;
            }
            }
            
            if(!isRowMerged && !isColMerged) {
            	worksheet.getAllocatedRange().autoFitColumns();
            worksheet.getAllocatedRange().autoFitRows();
            }*/

            int maxIndex = 0;
            double maxWidth = 0;
            for (int r = 0; r < rows.length; r++) {
                if (rows[r].hasMerged()) {
                    rows[r].autoFitColumns();
                    double endAutofit = rows[r].getColumns()[0].getColumnWidth();
                    if (endAutofit > maxWidth) {
                        maxWidth = endAutofit;
                        maxIndex = r;
                    }
                }
            }

            rows[maxIndex].autoFitColumns();
            isColMerged = true;

            PageSetup pageSetup = worksheet.getPageSetup();
            pageSetup.setPrintArea(null);
            // worksheet.saveToPdf(outputFileName);

            workbookTest.getWorksheets().add(worksheet.getName());
            Worksheet ws = workbookTest.getWorksheets().get(i);
            ws.copyFrom(worksheet);
            CellRange[] rw = ws.getRows();
            CellRange[] col = ws.getColumns();
            Boolean isRMerged = false;
            Boolean isCMerged = false;
            for (int r = 0; r < col.length; r++) {
                if (col[r].hasMerged()) {
                    col[r].autoFitRows();
                    isCMerged = true;
                }
            }
            for (int r = 0; r < rw.length; r++) {
                if (rw[r].hasMerged()) {
                    rw[r].autoFitColumns();
                    isRMerged = true;
                }
            }
            if (Boolean.TRUE.equals(!isRMerged) && Boolean.TRUE.equals(!isCMerged)) {
                ws.getAllocatedRange().autoFitRows();
                ws.getAllocatedRange().autoFitColumns();
            }
            for (int c = ws.getFirstColumn(); c <= ws.getLastColumn(); c++) {
                boolean columnIsHide = ws.getColumnIsHide(c);
                if (columnIsHide) {
                    ws.showColumn(c);
                }
                CellStyle style = ws.getDefaultColumnStyle(c);
                style.setShrinkToFit(true);
                style.setWrapText(false);
            }
            for (int r = ws.getFirstRow(); r <= ws.getLastRow(); r++) {
                boolean rowIsHide = ws.getRowIsHide(r);
                if (rowIsHide) {
                    ws.showRow(r);
                }
                CellStyle style = ws.getDefaultRowStyle(r);
                style.setShrinkToFit(true);
                style.setWrapText(false);
            }
            PageSetup ps = workbookTest.getWorksheets().get(i).getPageSetup();
            ps.setPrintArea(null);
        }
        workbookTest.saveToFile(outputFileName, FileFormat.PDF);
        workbookTest.dispose();
        // workbook.saveToFile(outputFileName, FileFormat.PDF);
        // workbook.dispose();
        System.out.println(Calendar.getInstance().getTime() + "------------ Processed file ::: " + file.getName());
    }
}
